package com.ruoyi.system.service.impl;

import java.util.ArrayList;
import java.util.List;

import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.system.domain.vo.SearchLocationInfoVo;
import com.ruoyi.system.mapper.TUserProfileMapper;
import com.ruoyi.system.service.ITDeviceListService;
import com.ruoyi.system.service.ITShouhuanInfoService;
import com.ruoyi.system.service.ITUserProfileService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.system.mapper.TSearchLocationInfoMapper;
import com.ruoyi.system.domain.TSearchLocationInfo;
import com.ruoyi.system.service.ITSearchLocationInfoService;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2023-09-16
 */
@Service
public class TSearchLocationInfoServiceImpl implements ITSearchLocationInfoService {
    private static final Logger log = LoggerFactory.getLogger(TSearchLocationInfoServiceImpl.class);

    @Autowired
    private TSearchLocationInfoMapper tSearchLocationInfoMapper;

    @Autowired
    private ITDeviceListService tDeviceListService;

    @Autowired
    private ITShouhuanInfoService itShouhuanInfoService;

    @Autowired
    private ITUserProfileService userProfileService;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override

    public TSearchLocationInfo selectTSearchLocationInfoById(Long id) {
        return tSearchLocationInfoMapper.selectTSearchLocationInfoById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param tSearchLocationInfo 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<TSearchLocationInfo> selectTSearchLocationInfoList(TSearchLocationInfo tSearchLocationInfo) {
        return tSearchLocationInfoMapper.selectTSearchLocationInfoList(tSearchLocationInfo);
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param tSearchLocationInfo 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertTSearchLocationInfo(TSearchLocationInfo tSearchLocationInfo) {
        tSearchLocationInfo.setCreateTime(DateUtils.getNowDate());
        return tSearchLocationInfoMapper.insertTSearchLocationInfo(tSearchLocationInfo);
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param tSearchLocationInfo 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateTSearchLocationInfo(TSearchLocationInfo tSearchLocationInfo) {
        tSearchLocationInfo.setUpdateTime(DateUtils.getNowDate());
        return tSearchLocationInfoMapper.updateTSearchLocationInfo(tSearchLocationInfo);
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteTSearchLocationInfoByIds(Long[] ids) {
        return tSearchLocationInfoMapper.deleteTSearchLocationInfoByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteTSearchLocationInfoById(Long id) {
        return tSearchLocationInfoMapper.deleteTSearchLocationInfoById(id);
    }

    @Override
    public List<SearchLocationInfoVo> selectSearchLocationInfoVoBySearchValue(TSearchLocationInfo tSearchLocationInfo) {
        //判断查询内容是否为空
        if (StringUtils.isEmpty(tSearchLocationInfo.getSearchValue())) {
            log.error("当前查询内容禁止为空,查询者id：{}", tSearchLocationInfo.getUserId());
            throw new ServiceException("当前查询内容禁止为空！");
        }
        //查询内容
        String searchValue = tSearchLocationInfo.getSearchValue();
        return tSearchLocationInfoMapper.selectSearchLocationInfoVoBySearchValue(searchValue);
    }
}
